Sessions
Create a session
Create a session for a task. Provide the initial prompt in description and optionally configure its repositories, agent, and Build (normal) or Plan (planning) mode. New sessions are private to their creator until shared through grants.
POST
/
v1
/
sessions
TypeScript SDK
import Tembo from '@tembo-io/sdk';
const client = new Tembo();
const session = await client.sessions.create({
description: 'Fix the authentication bug in the login component',
projectId: 'your-project-id',
agent: 'claudeCode:claude-fable-5-1',
codeRepositoryIds: ['123e4567-e89b-12d3-a456-426614174000'],
baseBranch: 'main',
targetBranch: 'main',
visibility: 'private',
mcpServers: [],
});use tembo_rs::*;
let client = Tembo::from_env()?;
let response = client
.sessions()
.create(
SessionsCreateBody::new("Fix the authentication bug in the login component".to_string())
.with_agent("claudeCode:claude-fable-5-1".to_string())
.with_base_branch("main".to_string())
.with_mcp_servers(vec![])
.with_project_id("your-project-id".to_string())
.with_target_branch("main".to_string())
.with_code_repository_ids(vec!["123e4567-e89b-12d3-a456-426614174000".to_string()])
.with_visibility(SessionsCreateBodyVisibility::Private),
)
.send()
.await?;
curl --request POST \
--url https://api.tembo.io/v1/sessions \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
{
"description": "Fix the authentication bug in the login component",
"projectId": "your-project-id",
"agent": "claudeCode:claude-fable-5-1",
"codeRepositoryIds": [
"123e4567-e89b-12d3-a456-426614174000"
],
"baseBranch": "main",
"targetBranch": "main",
"visibility": "private",
"mcpServers": []
}
'import requests
url = "https://api.tembo.io/v1/sessions"
payload = {
"description": "Fix the authentication bug in the login component",
"projectId": "your-project-id",
"agent": "claudeCode:claude-fable-5-1",
"codeRepositoryIds": ["123e4567-e89b-12d3-a456-426614174000"],
"baseBranch": "main",
"targetBranch": "main",
"visibility": "private",
"mcpServers": []
}
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify({
description: 'Fix the authentication bug in the login component',
projectId: 'your-project-id',
agent: 'claudeCode:claude-fable-5-1',
codeRepositoryIds: ['123e4567-e89b-12d3-a456-426614174000'],
baseBranch: 'main',
targetBranch: 'main',
visibility: 'private',
mcpServers: []
})
};
fetch('https://api.tembo.io/v1/sessions', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://api.tembo.io/v1/sessions",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'description' => 'Fix the authentication bug in the login component',
'projectId' => 'your-project-id',
'agent' => 'claudeCode:claude-fable-5-1',
'codeRepositoryIds' => [
'123e4567-e89b-12d3-a456-426614174000'
],
'baseBranch' => 'main',
'targetBranch' => 'main',
'visibility' => 'private',
'mcpServers' => [
]
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://api.tembo.io/v1/sessions"
payload := strings.NewReader("{\n \"description\": \"Fix the authentication bug in the login component\",\n \"projectId\": \"your-project-id\",\n \"agent\": \"claudeCode:claude-fable-5-1\",\n \"codeRepositoryIds\": [\n \"123e4567-e89b-12d3-a456-426614174000\"\n ],\n \"baseBranch\": \"main\",\n \"targetBranch\": \"main\",\n \"visibility\": \"private\",\n \"mcpServers\": []\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://api.tembo.io/v1/sessions")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"description\": \"Fix the authentication bug in the login component\",\n \"projectId\": \"your-project-id\",\n \"agent\": \"claudeCode:claude-fable-5-1\",\n \"codeRepositoryIds\": [\n \"123e4567-e89b-12d3-a456-426614174000\"\n ],\n \"baseBranch\": \"main\",\n \"targetBranch\": \"main\",\n \"visibility\": \"private\",\n \"mcpServers\": []\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://api.tembo.io/v1/sessions")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"description\": \"Fix the authentication bug in the login component\",\n \"projectId\": \"your-project-id\",\n \"agent\": \"claudeCode:claude-fable-5-1\",\n \"codeRepositoryIds\": [\n \"123e4567-e89b-12d3-a456-426614174000\"\n ],\n \"baseBranch\": \"main\",\n \"targetBranch\": \"main\",\n \"visibility\": \"private\",\n \"mcpServers\": []\n}"
response = http.request(request)
puts response.read_body{
"agent": "<string>",
"agentId": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"artifactType": "PullRequest",
"baseBranch": "<string>",
"branchName": "<string>",
"createdAt": "2023-11-07T05:31:56Z",
"externalId": "<string>",
"externalUrl": "<string>",
"id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"kind": "<string>",
"lastQueuedAt": "2023-11-07T05:31:56Z",
"lastSeenAt": "2023-11-07T05:31:56Z",
"level": 0,
"mode": "normal",
"parentSessionId": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"projectId": "<string>",
"sandboxSize": "nano",
"sessionType": "Chat",
"targetBranch": "<string>",
"title": "<string>",
"updatedAt": "2023-11-07T05:31:56Z",
"visibility": "private",
"artifacts": [
{
"id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"type": "PullRequest",
"createdAt": "2023-11-07T05:31:56Z",
"updatedAt": "2023-11-07T05:31:56Z",
"pullRequests": [
{
"id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"url": "<string>",
"title": "<string>",
"status": "open",
"isDraft": true,
"sourceBranch": "<string>",
"createdAt": "2023-11-07T05:31:56Z",
"agent": "<string>",
"diff": {
"additions": 4503599627370495,
"deletions": 4503599627370495,
"data": "<string>"
},
"updatedAt": "2023-11-07T05:31:56Z",
"baseBranch": "<string>",
"headSha": "<string>",
"author": {
"avatarUrl": "<string>",
"login": "<string>"
},
"codeRepository": {
"id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"name": "<string>",
"owner": "<string>",
"baseBranch": "<string>",
"provider": "<string>"
}
}
]
}
],
"automaticSizing": true,
"description": "<string>",
"diffSummary": {
"additions": 0,
"deletions": 0
},
"folderId": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"htmlUrl": "<string>",
"isPinned": true,
"project": {
"id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"name": "<string>",
"icon": "folder",
"color": "neutral"
},
"sessionSource": {
"id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"name": "<string>",
"type": "<string>",
"repositories": [
{
"id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"name": "<string>",
"provider": "<string>"
}
]
},
"sourcePullRequest": {
"id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"url": "<string>",
"title": "<string>",
"status": "open",
"isDraft": true
},
"state": {
"isQueued": true,
"isCancelled": true,
"isCompleted": true,
"isFailed": true,
"inProgress": true,
"current": "inProgress"
}
}{
"error": "<string>"
}{
"error": "<string>"
}{
"error": "<string>"
}{
"error": "<string>"
}{
"error": "<string>"
}{
"error": "<string>"
}{
"error": "<string>"
}Authorizations
Body
application/json
Optional rich-text representation of the initial task. Provide description separately.
- Option 1
- Option 2
- Option 3
- Option 4
- Option 5
- Option 6
- Option 7
- Option 8
Show child attributes
Show child attributes
Example:
{
"type": "doc",
"content": [
{
"type": "paragraph",
"content": [{ "type": "text", "text": "Hello" }]
}
]
}
Response
Create a session
Pattern:
^(?:(?:\d\d[2468][048]|\d\d[13579][26]|\d\d0[48]|[02468][048]00|[13579][26]00)-02-29|\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\d|30)|(?:02)-(?:0[1-9]|1\d|2[0-8])))T(?:(?:[01]\d|2[0-3]):[0-5]\d:[0-5]\d(?:\.\d+)?(?:Z))$Pattern:
^(?:(?:\d\d[2468][048]|\d\d[13579][26]|\d\d0[48]|[02468][048]00|[13579][26]00)-02-29|\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\d|30)|(?:02)-(?:0[1-9]|1\d|2[0-8])))T(?:(?:[01]\d|2[0-3]):[0-5]\d:[0-5]\d(?:\.\d+)?(?:Z))$Was this page helpful?
⌘I
TypeScript SDK
import Tembo from '@tembo-io/sdk';
const client = new Tembo();
const session = await client.sessions.create({
description: 'Fix the authentication bug in the login component',
projectId: 'your-project-id',
agent: 'claudeCode:claude-fable-5-1',
codeRepositoryIds: ['123e4567-e89b-12d3-a456-426614174000'],
baseBranch: 'main',
targetBranch: 'main',
visibility: 'private',
mcpServers: [],
});use tembo_rs::*;
let client = Tembo::from_env()?;
let response = client
.sessions()
.create(
SessionsCreateBody::new("Fix the authentication bug in the login component".to_string())
.with_agent("claudeCode:claude-fable-5-1".to_string())
.with_base_branch("main".to_string())
.with_mcp_servers(vec![])
.with_project_id("your-project-id".to_string())
.with_target_branch("main".to_string())
.with_code_repository_ids(vec!["123e4567-e89b-12d3-a456-426614174000".to_string()])
.with_visibility(SessionsCreateBodyVisibility::Private),
)
.send()
.await?;
curl --request POST \
--url https://api.tembo.io/v1/sessions \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
{
"description": "Fix the authentication bug in the login component",
"projectId": "your-project-id",
"agent": "claudeCode:claude-fable-5-1",
"codeRepositoryIds": [
"123e4567-e89b-12d3-a456-426614174000"
],
"baseBranch": "main",
"targetBranch": "main",
"visibility": "private",
"mcpServers": []
}
'import requests
url = "https://api.tembo.io/v1/sessions"
payload = {
"description": "Fix the authentication bug in the login component",
"projectId": "your-project-id",
"agent": "claudeCode:claude-fable-5-1",
"codeRepositoryIds": ["123e4567-e89b-12d3-a456-426614174000"],
"baseBranch": "main",
"targetBranch": "main",
"visibility": "private",
"mcpServers": []
}
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify({
description: 'Fix the authentication bug in the login component',
projectId: 'your-project-id',
agent: 'claudeCode:claude-fable-5-1',
codeRepositoryIds: ['123e4567-e89b-12d3-a456-426614174000'],
baseBranch: 'main',
targetBranch: 'main',
visibility: 'private',
mcpServers: []
})
};
fetch('https://api.tembo.io/v1/sessions', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://api.tembo.io/v1/sessions",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'description' => 'Fix the authentication bug in the login component',
'projectId' => 'your-project-id',
'agent' => 'claudeCode:claude-fable-5-1',
'codeRepositoryIds' => [
'123e4567-e89b-12d3-a456-426614174000'
],
'baseBranch' => 'main',
'targetBranch' => 'main',
'visibility' => 'private',
'mcpServers' => [
]
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://api.tembo.io/v1/sessions"
payload := strings.NewReader("{\n \"description\": \"Fix the authentication bug in the login component\",\n \"projectId\": \"your-project-id\",\n \"agent\": \"claudeCode:claude-fable-5-1\",\n \"codeRepositoryIds\": [\n \"123e4567-e89b-12d3-a456-426614174000\"\n ],\n \"baseBranch\": \"main\",\n \"targetBranch\": \"main\",\n \"visibility\": \"private\",\n \"mcpServers\": []\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://api.tembo.io/v1/sessions")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"description\": \"Fix the authentication bug in the login component\",\n \"projectId\": \"your-project-id\",\n \"agent\": \"claudeCode:claude-fable-5-1\",\n \"codeRepositoryIds\": [\n \"123e4567-e89b-12d3-a456-426614174000\"\n ],\n \"baseBranch\": \"main\",\n \"targetBranch\": \"main\",\n \"visibility\": \"private\",\n \"mcpServers\": []\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://api.tembo.io/v1/sessions")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"description\": \"Fix the authentication bug in the login component\",\n \"projectId\": \"your-project-id\",\n \"agent\": \"claudeCode:claude-fable-5-1\",\n \"codeRepositoryIds\": [\n \"123e4567-e89b-12d3-a456-426614174000\"\n ],\n \"baseBranch\": \"main\",\n \"targetBranch\": \"main\",\n \"visibility\": \"private\",\n \"mcpServers\": []\n}"
response = http.request(request)
puts response.read_body{
"agent": "<string>",
"agentId": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"artifactType": "PullRequest",
"baseBranch": "<string>",
"branchName": "<string>",
"createdAt": "2023-11-07T05:31:56Z",
"externalId": "<string>",
"externalUrl": "<string>",
"id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"kind": "<string>",
"lastQueuedAt": "2023-11-07T05:31:56Z",
"lastSeenAt": "2023-11-07T05:31:56Z",
"level": 0,
"mode": "normal",
"parentSessionId": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"projectId": "<string>",
"sandboxSize": "nano",
"sessionType": "Chat",
"targetBranch": "<string>",
"title": "<string>",
"updatedAt": "2023-11-07T05:31:56Z",
"visibility": "private",
"artifacts": [
{
"id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"type": "PullRequest",
"createdAt": "2023-11-07T05:31:56Z",
"updatedAt": "2023-11-07T05:31:56Z",
"pullRequests": [
{
"id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"url": "<string>",
"title": "<string>",
"status": "open",
"isDraft": true,
"sourceBranch": "<string>",
"createdAt": "2023-11-07T05:31:56Z",
"agent": "<string>",
"diff": {
"additions": 4503599627370495,
"deletions": 4503599627370495,
"data": "<string>"
},
"updatedAt": "2023-11-07T05:31:56Z",
"baseBranch": "<string>",
"headSha": "<string>",
"author": {
"avatarUrl": "<string>",
"login": "<string>"
},
"codeRepository": {
"id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"name": "<string>",
"owner": "<string>",
"baseBranch": "<string>",
"provider": "<string>"
}
}
]
}
],
"automaticSizing": true,
"description": "<string>",
"diffSummary": {
"additions": 0,
"deletions": 0
},
"folderId": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"htmlUrl": "<string>",
"isPinned": true,
"project": {
"id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"name": "<string>",
"icon": "folder",
"color": "neutral"
},
"sessionSource": {
"id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"name": "<string>",
"type": "<string>",
"repositories": [
{
"id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"name": "<string>",
"provider": "<string>"
}
]
},
"sourcePullRequest": {
"id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"url": "<string>",
"title": "<string>",
"status": "open",
"isDraft": true
},
"state": {
"isQueued": true,
"isCancelled": true,
"isCompleted": true,
"isFailed": true,
"inProgress": true,
"current": "inProgress"
}
}{
"error": "<string>"
}{
"error": "<string>"
}{
"error": "<string>"
}{
"error": "<string>"
}{
"error": "<string>"
}{
"error": "<string>"
}{
"error": "<string>"
}